Bug 858287 - Review Request: gap-io - Unix I/O functionality for GAP
Summary: Review Request: gap-io - Unix I/O functionality for GAP
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Paulo Andrade
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-09-18 14:51 UTC by Jerry James
Modified: 2012-12-09 13:52 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-12-09 13:52:41 UTC
Type: ---
paulo.cesar.pereira.de.andrade: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jerry James 2012-09-18 14:51:59 UTC
Spec URL: http://jjames.fedorapeople.org/gap-io/gap-io.spec
SRPM URL: http://jjames.fedorapeople.org/gap-io/gap-io-4.2-1.fc19.src.rpm
Description: This GAP package provides a link to the standard UNIX I/O functionality that is available through the C library.  This part basically consists of functions on the GAP level that allow functions in the C library to be called.  Higher layers provide buffered I/O, IPC, HTTP access, and object serialization.
Fedora Account System Username: jjames

Comment 1 Paulo Andrade 2012-09-19 03:17:04 UTC
  Overall, the package looks very good, but for completeness I
suggest some extra polishing:

  Some work should be done to test the dynamic module, by adding
a %check section. This would allow triggering a broken package
in a build in another arch, or the package becoming broken for
some reason in a rebuild. I did run the tests locally and did
not find any issues, but they may be not trivial to test because
the way the tests are run, and could require some extra logic
added to autotools files to add a check make target.

  The package named is gap-io instead of io as is the tarball
name is valid and desirable.

  You should consider to patch Makefile.am and submit the
changes to upstream, so that it would be able to actually
run make install. Changes should be minimal, but there may be
issues with different install layouts, or it would just show
any existing inconsistency.

---%<---

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.
     Note: Unversioned so-files in non-devel package (fix or explain):gap-
     io-4.2-1.fc19.x86_64.rpm : /usr/lib/gap/pkg/io/bin/x86_64-redhat-linux-
     gnu-gcc-default64/io.so


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)" For detailed output of licensecheck see file:
     /home/pcpa/rpmbuild/858287-gap-io/licensecheck.txt
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL5 is required
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX tarball generation or download is documented.
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0 (io-4.2.tar.gz)
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Rpmlint
-------
Checking: gap-io-debuginfo-4.2-1.fc19.x86_64.rpm
          gap-io-4.2-1.fc19.x86_64.rpm
          gap-io-4.2-1.fc19.src.rpm
gap-io.x86_64: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, intercessors
gap-io.x86_64: W: spelling-error %description -l en_US builtin -> built in, built-in, built
gap-io.src: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, intercessors
gap-io.src: W: spelling-error %description -l en_US builtin -> built in, built-in, built
3 packages and 0 specfiles checked; 0 errors, 4 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint gap-io
gap-io.x86_64: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, intercessors
gap-io.x86_64: W: spelling-error %description -l en_US builtin -> built in, built-in, built
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'

Requires
--------
gap-io-debuginfo-4.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    

gap-io-4.2-1.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/update-gap-workspace
    gap-core
    libc.so.6()(64bit)
    rtld(GNU_HASH)

Provides
--------
gap-io-debuginfo-4.2-1.fc19.x86_64.rpm:
    
    gap-io-debuginfo = 4.2-1.fc19
    gap-io-debuginfo(x86-64) = 4.2-1.fc19

gap-io-4.2-1.fc19.x86_64.rpm:
    
    gap-io = 4.2-1.fc19
    gap-io(x86-64) = 4.2-1.fc19
    gap-pkg-io = 4.2-1.fc19
    io.so()(64bit)

MD5-sum check
-------------
http://www-groups.mcs.st-and.ac.uk/~neunhoef/Computer/Software/Gap/io/io-4.2.tar.gz :
  CHECKSUM(SHA256) this package     : 8fb6209d180304b51542abc21d574e12fc5eb8b5031645cbd18721c84d58f04b
  CHECKSUM(SHA256) upstream package : 8fb6209d180304b51542abc21d574e12fc5eb8b5031645cbd18721c84d58f04b


Generated by fedora-review 0.2.2 (9f8c0e5) last change: 2012-08-09
Command line :/usr/bin/fedora-review -b 858287
External plugins:

Comment 2 Jerry James 2012-10-10 22:40:05 UTC
Thanks for the review!  I have added %check script, as requested.  New URLs:

Spec URL: http://jjames.fedorapeople.org/gap-io/gap-io.spec
SRPM URL: http://jjames.fedorapeople.org/gap-io/gap-io-4.2-1.fc19.src.rpm

Note that unversioned .so files are normal for plugins.  The versioned .so files are really only needed in %{_libdir}, so that applications that link against them will have broken dependencies when the library is updated.  That isn't the case for plugins, which go in private directories because they are not for general application consumption.

Comment 3 Paulo Andrade 2012-10-20 03:05:39 UTC
Correct srpm link:
http://jjames.fedorapeople.org/gap-io/gap-io-4.2-2.fc19.src.rpm

The suggestion about correcting make install was to try to
ensure the package is properly installed, in case it needs
some special procedures during install, but besides broken
install target, the package is simple enough to easily
validated, and pass %check in spec as well as work in simple
tests after install.

Only issue, that you should correct when creating the
git repository is to correct mixed $RPM_BUILD_ROOT and
%{buildroot} usage.

I consider the package approved.

---%<---

Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros


===== MUST items =====

C/C++:
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 2 files have unknown
     license. Detailed output of licensecheck in /home/pcpa/rpmbuild/review-
     gap-io/licensecheck.txt
[!]: Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
[!]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (io-4.2.tar.gz)
[x]: SourceX is a working URL.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: gap-io-4.2-2.fc19.x86_64.rpm
          gap-io-4.2-2.fc19.src.rpm
          gap-io-debuginfo-4.2-2.fc19.x86_64.rpm
gap-io.x86_64: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, intercession
gap-io.x86_64: W: spelling-error %description -l en_US builtin -> built in, built-in, built
gap-io.src: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, intercession
gap-io.src: W: spelling-error %description -l en_US builtin -> built in, built-in, built
3 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint gap-io-debuginfo gap-io
gap-io.x86_64: W: spelling-error %description -l en_US interprocess -> inter process, inter-process, intercession
gap-io.x86_64: W: spelling-error %description -l en_US builtin -> built in, built-in, built
2 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
gap-io-4.2-2.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/update-gap-workspace
    gap-core
    libc.so.6()(64bit)
    rtld(GNU_HASH)

gap-io-debuginfo-4.2-2.fc19.x86_64.rpm (rpmlib, GLIBC filtered):
    



Provides
--------
gap-io-4.2-2.fc19.x86_64.rpm:
    
    gap-io = 4.2-2.fc19
    gap-io(x86-64) = 4.2-2.fc19
    gap-pkg-io = 4.2-2.fc19
    io.so()(64bit)

gap-io-debuginfo-4.2-2.fc19.x86_64.rpm:
    
    gap-io-debuginfo = 4.2-2.fc19
    gap-io-debuginfo(x86-64) = 4.2-2.fc19



Unversioned so-files
--------------------
gap-io-4.2-2.fc19.x86_64.rpm: /usr/lib/gap/pkg/io/bin/x86_64-redhat-linux-gnu-gcc-default64/io.so

MD5-sum check
-------------
http://www-groups.mcs.st-and.ac.uk/~neunhoef/Computer/Software/Gap/io/io-4.2.tar.gz :
  CHECKSUM(SHA256) this package     : 8fb6209d180304b51542abc21d574e12fc5eb8b5031645cbd18721c84d58f04b
  CHECKSUM(SHA256) upstream package : 8fb6209d180304b51542abc21d574e12fc5eb8b5031645cbd18721c84d58f04b


Generated by fedora-review 0.3.0 (c78e275) last change: 2012-09-24
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -v -r -n gap-io

Comment 4 Jerry James 2012-10-20 16:47:38 UTC
(In reply to comment #3)
> The suggestion about correcting make install was to try to
> ensure the package is properly installed, in case it needs
> some special procedures during install, but besides broken
> install target, the package is simple enough to easily
> validated, and pass %check in spec as well as work in simple
> tests after install.

Yes, I'll try to figure out how to fix make install and pass the information upstream, but it doesn't seem to be a trivial fix.

> Only issue, that you should correct when creating the
> git repository is to correct mixed $RPM_BUILD_ROOT and
> %{buildroot} usage.

Oops.  Good catch.  I'll fix that before importing the SRPM.  Thanks for the review!

Comment 5 Jerry James 2012-10-20 16:49:32 UTC
New Package SCM Request
=======================
Package Name: gap-io
Short Description: Unix I/O functionality for GAP
Owners: jjames
Branches: f18
InitialCC:

Comment 6 Gwyn Ciesla 2012-10-22 12:04:53 UTC
Git done (by process-git-requests).

Comment 7 Fedora Update System 2012-10-22 17:57:19 UTC
gap-io-4.2-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/gap-io-4.2-2.fc18

Comment 8 Fedora Update System 2012-10-23 06:49:37 UTC
gap-io-4.2-2.fc18 has been pushed to the Fedora 18 testing repository.

Comment 9 Paulo Andrade 2012-12-09 13:52:41 UTC
<bodhi> - 2012-11-08 05:40:19 This update has been pushed to stable

guess bug can be closed.


Note You need to log in before you can comment on or make changes to this bug.